import classNames from "classnames";
import React, { useEffect, useRef, useState } from "react";
import { alignElement } from "utils-dom";
import { EXITED, UNMOUNTED, useControll, useOutsideClick, usePortal, useTranstion, useTriggerChain } from "utils-hooks";
import { getPlacements } from "./placements";
import TriggerWrap from "./TriggerWrap";
// Tips: 自定义的 prefixCls , 必须确保提供的样式有动画或者过度，并且有 position: absolute, 不然元素宽度是100%
export function Trigger(props) {
    var _a;
    var _b = props.prefixCls, prefixCls = _b === void 0 ? "xy-trigger" : _b, className = props.className, style = props.style, getContainer = props.getContainer, _c = props.placement, placement = _c === void 0 ? "bottomLeft" : _c, children = props.children, popup = props.popup, popupAlign = props.popupAlign, popupClassName = props.popupClassName, popupClickHide = props.popupClickHide, destroyPopupOnHide = props.destroyPopupOnHide, offsetSize = props.offsetSize, stretch = props.stretch, onAlign = props.onAlign, alignRef = props.alignRef, allowCustom = props.allowCustom, _d = props.mouseDelay, mouseDelay = _d === void 0 ? 100 : _d, _e = props.action, action = _e === void 0 ? ["hover"] : _e, onChange = props.onChange;
    var renderPortal = usePortal(popupClassName, getContainer)[0];
    var _f = useControll(props, "visible", "defaultVisible", false), visible = _f[0], setVisible = _f[1], isControll = _f[2];
    var _g = useState(null), flip = _g[0], setFlip = _g[1];
    var _h = useTranstion(visible), ref = _h[0], state = _h[1];
    var triggerRef = useRef(null);
    var opening = state.indexOf("en") !== -1;
    var classString = classNames(prefixCls, className, prefixCls + "-" + (flip || placement), prefixCls + "-state-" + state, (_a = {}, _a[prefixCls + "-open"] = opening, _a));
    var style1 = {
        width: stretch && triggerRef.current ? triggerRef.current.clientWidth : null,
    };
    var setActived = useTriggerChain(triggerRef, ref, function (act, actived, event) {
        if (action && action.length > 0) {
            doSetVisible(isControll ? !visible : actived, event);
        }
    }, { trigger: action, mouseDelay: mouseDelay }, [flip, visible]);
    useOutsideClick(popupClickHide ? [triggerRef.current] : [ref.current, triggerRef.current], function (event) {
        if (visible) {
            doSetVisible(false, event);
            setActived(false);
        }
    }, [visible]);
    useEffect(function () {
        var popupEle = ref.current;
        if ((popupEle && state === EXITED) || state === UNMOUNTED) {
            popupEle.style.left = "-100%";
            popupEle.style.display = "block";
        }
    }, [state]);
    function align(restAnimation) {
        if (restAnimation === void 0) { restAnimation = true; }
        var popupEle = ref.current;
        if (!popupEle) {
            return;
        }
        if (visible) {
            var config = Object.assign({}, getPlacements(offsetSize)[placement], popupAlign);
            var revise = alignElement(popupEle, triggerRef.current, config, restAnimation);
            if (onAlign) {
                onAlign(triggerRef.current, popupEle);
            }
            if (revise.x && !revise.y) {
                setFlip(config.flipX);
            }
            else if (!revise.x && revise.y) {
                setFlip(config.flipY);
            }
            else if (revise.x && revise.y) {
                setFlip(config.flipAll);
            }
            else {
                setFlip(null);
            }
        }
    }
    if (alignRef) {
        alignRef.current = align;
    }
    useEffect(align, [visible]);
    function doSetVisible(_visible, event) {
        if (_visible === visible) {
            return;
        }
        if (!isControll) {
            setVisible(_visible);
        }
        if (onChange) {
            onChange(_visible, event);
        }
    }
    function clickHandle(e) {
        e.stopPropagation();
    }
    return (React.createElement(React.Fragment, null,
        TriggerWrap(children, triggerRef, classNames(prefixCls + "-trigger", prefixCls + "-trigger-state-" + state), allowCustom),
        renderPortal(destroyPopupOnHide === true && (!visible && state === EXITED) ? null : (React.createElement("div", { className: classString, style: Object.assign({}, style, style1), ref: ref, onClick: clickHandle }, popup)))));
}
export default React.memo(Trigger);
//# sourceMappingURL=index.js.map